package com.platform.yijia.dao;

import com.platform.yijia.pojo.StationClassStructure;

import java.util.List;

/**
 * 班结管理Mapper接口
 *
 * @author yijia
 * @date 2020-12-31
 */
public interface StationClassStructureMapper
{
    /**
     * 查询班结管理
     *
     * @param id 班结管理ID
     * @return 班结管理
     */
    public StationClassStructure selectStationClassStructureById(Long id);

    /**
     * 查询班结管理列表
     *
     * @param stationClassStructure 班结管理
     * @return 班结管理集合
     */
    public List<StationClassStructure> selectStationClassStructureList(StationClassStructure stationClassStructure);

    /**
     * 新增班结管理
     *
     * @param stationClassStructure 班结管理
     * @return 结果
     */
    public int insertStationClassStructure(StationClassStructure stationClassStructure);

    /**
     * 修改班结管理
     *
     * @param stationClassStructure 班结管理
     * @return 结果
     */
    public int updateStationClassStructure(StationClassStructure stationClassStructure);

    /**
     * 删除班结管理
     *
     * @param id 班结管理ID
     * @return 结果
     */
    public int deleteStationClassStructureById(Long id);

    /**
     * 批量删除班结管理
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteStationClassStructureByIds(Long[] ids);

    /**
     *
     * @param stationClassStructure
     * @return
     */
    public  List<StationClassStructure> listPersonnelStructure(StationClassStructure stationClassStructure);

    /**
     *
     * @param classes
     * @return
     */
    public StationClassStructure selectStationClassStructureMax(StationClassStructure classes);

    /**
     *
     * @param stationClassStructure
     * @return
     */
    public List<StationClassStructure> listOilStructure(StationClassStructure stationClassStructure);

    /**
     * 查询今天班结了几次生成班结
     * @param classesStructure
     * @return
     */
    public StationClassStructure selectDistnctClassStructure(StationClassStructure classesStructure);

    /**
     * 根据班次号汇总班结数据
     * @param scs
     * @return
     */
    public StationClassStructure selectSummyClassStructure(StationClassStructure scs);

    /**
     * 按员工支付方式汇总班结数据
     * @param stationClassStructure
     * @return
     */
    public List<StationClassStructure> listPersonnelPayStructure(StationClassStructure stationClassStructure);
/*获取当前人班结信息
 */
    public  StationClassStructure listClass(StationClassStructure stationClassStructure);

    /**
     * 导出数据
     * @param stationClassStructure
     * @return
     */
    public List<StationClassStructure> selectStationClassStructureExport(StationClassStructure stationClassStructure);

    /***
     * 根据支付方式汇总数据
     * @param classStructure
     * @return
     */
    public List<StationClassStructure> listPayStructure(StationClassStructure classStructure);
}
