package com.platform.yijia.pojo;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

/**
 * 班结汇总对象 station_classes_summary
 *
 * @author yijia
 * @date 2021-01-27
 */
@Data
public class StationClassesSummary
{
    private static final long serialVersionUID = 1L;

    /** 班结主键id */
    private Long id;

    /** 班次号 */
    private String classesNo;

    /** 班次开始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date startDate;

    /** 班次结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date endDate;

    /** 油站id */
    private Integer stationId;

    /** 油站名称 */
    private String stationName;

    /** 订单数 */
    private Integer orderNum;

    /** 小票数量 */
    private Integer printNum;

    /** 销量L */
    private BigDecimal saleLiters;

    /** 应收金额 */
    private BigDecimal saleAmt;

    /** 实际支付金额 */
    private BigDecimal amt;

    /** 优惠金额 */
    private BigDecimal discountAmt;

    /** 微信实际支付金额 */
    private BigDecimal wxAmt;

    /** 支付宝实际支付金额 */
    private BigDecimal zfbAmt;

    /** 电子卡实际支付金额 */
    private BigDecimal dzkAmt;

    /** 班结人 */
    private String classesMan;

    private List<String> stationIdList;

}
